﻿@page "/program-detail/{PageModeName}"
@page "/program-detail/{PageModeName}/{Id:int}"

<PageTitle Title=@($"プログラム詳細({pageMode.DisplayValue})") />
<EditForm Model="@program" OnValidSubmit="OnValidSubmit" class="mt-2">
    <DataAnnotationsValidator />
    <MudCard>
        <MudCardContent>
            <TagInput @bind-AddedTags="AddedTags" Count="5" />
            <MudTextField Label="@program.GetDisplayName(p => p.ProgramId)"
                          @bind-Value="program.ProgramId"
                          For="@(() => program.ProgramId)"
                          ReadOnly="pageMode.IsReadOnly" />
            <MudTextField Label="@program.GetDisplayName(p => p.ProgramName)"
                          @bind-Value="program.ProgramName"
                          For="@(() => program.ProgramName)"
                          ReadOnly="pageMode.IsReadOnly" />
            <MudTextField Label="@program.GetDisplayName(p => p.Purpose)"
                          @bind-Value="program.Purpose"
                          For="@(() => program.Purpose)"
                          ReadOnly="pageMode.IsReadOnly" />
            <MudTextField Label="@program.GetDisplayName(p => p.FunctionalOverview)"
                          @bind-Value="program.FunctionalOverview"
                          For="@(() => program.FunctionalOverview)"
                          ReadOnly="pageMode.IsReadOnly" />
        </MudCardContent>
        <MudCardActions>
            @if (!pageMode.Equals(PageMode.Show))
            {
                <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="@(pageMode.Equals(PageMode.Delete) ? Color.Secondary : Color.Primary)" Class="mr-4">@pageMode.DisplayValue</MudButton>
            }
            <MudButton Variant="Variant.Filled" Link="/program-list">戻る</MudButton>
        </MudCardActions>
    </MudCard>

    @foreach (var addedTag in AddedTags)
    {
        <MudText>@addedTag</MudText>
    }
</EditForm>

@code {
    [Parameter]
    public string PageModeName { get; set; }

    [Parameter]
    public int Id { get; set; }

    private PageMode pageMode = new(1);
    private ProgramEntity program = new();

    public List<string> AddedTags = new();

    protected override void OnParametersSet()
    {
        pageMode = new(PageModeName);
    }

    protected async override Task OnInitializedAsync()
    {
        if (Id != 0)
        {
            try
            {
                program = await HttpClient.GetFromJsonAsync<ProgramEntity>($"api/Programs/{Id}");
                foreach (var tag in program.Tags)
                {
                    AddedTags.Add(tag.TagName);
                }
            }
            catch (Exception ex)
            {
                Snackbar.Add(ex.Message, Severity.Success);
            }
        }
    }

    private async Task OnValidSubmit(EditContext context)
    {
        try
        {
            if (pageMode == PageMode.Create)
            {
                program.Tags = new List<TagEntity>();
                foreach (var addedTag in AddedTags)
                {
                    //TagEntity dbTag = await HttpClient.GetFromJsonAsync<TagEntity>($"api/Tags/{addedTag}");
                    //if (dbTag == null)
                    //{
                    //    program.Tags.Add(new TagEntity()
                    //    {
                    //        TagName = addedTag
                    //    });
                    //}
                    //else
                    //{
                    //    program.Tags.Add(dbTag);
                    //}
                    program.Tags.Add(new TagEntity()
                    {
                        TagName = addedTag
                    });
                }
                await HttpClient.PostAsJsonAsync<ProgramEntity>("api/Programs", program);
            }
            else if (pageMode == PageMode.Edit)
            {
                await HttpClient.PutAsJsonAsync<ProgramEntity>($"api/Programs/{Id}", program);
            }
            else if (pageMode == PageMode.Delete)
            {
                await HttpClient.DeleteAsync($"api/Programs/{Id}");
            }
        }
        catch (Exception ex)
        {
            Snackbar.Add(ex.Message, Severity.Error);
        }

        NavigationManager.NavigateTo("/program-list");
        StateHasChanged();
    }

}